package latex;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub latex2html {
# We shall build a database of external references for LaTeX2HTML
    open(LATEX2HTML,">$main::DIRE/latex2html.pl") or die "DBM Error for l2h";
    local($reference,$file,$tag) = ("","","");
    print LATEX2HTML "# ftagshtml $main::version external references for\n";
    print LATEX2HTML "# LaTeX2HTML 98.1p1 release (March 2nd, 1998)\n";
    print LATEX2HTML "# Associate labels original text with physical files.\n\n";
    foreach $reference (keys %main::label) {
	($file,$tag) = split (/\#/,$main::label{$reference});
	$file .= "_c.html" ;
	print LATEX2HTML '$external_labels{"'.$tag.'"} = "$URL/'.$file."\";\n";
    }
    print LATEX2HTML "\n1;\n";
    close(LATEX2HTML);
}
#|#######################################################
sub Index_T_Latex {
# index des fonctions
    open(LATEX,">$main::DIRE/texindex.tex");
    &Ouvre_SLatex ;
    &Ouvre_LLatex ;
    $lang = "LaTeX";
    if (%main::programmes) {
	@liste=sort keys %main::programmes ;
	print LATEX main::Build_Index_Chapter("source","index","Programme",$lang,@liste);
    }
    if (%main::functions) {
	@liste=sort keys %main::functions ;
	print LATEX main::Build_Index_Chapter("source","index","Functions",$lang,@liste);
    }
    if (%main::routines) {
	@liste=sort keys %main::routines ;
	print LATEX main::Build_Index_Chapter("source","index","Routines",$lang,@liste);
    }
    if (%main::module) {
	@liste=sort keys %main::module ;
	print LATEX main::Build_Index_Chapter("source","index","Modules",$lang,@liste);
    }
    if (%main::interfaces) {
	@liste=sort keys %main::interfaces ;
	print LATEX main::Build_Index_Chapter("source","index","Interfaces",$lang,@liste);
    }
    if (%{main::f90included}) {
	@liste=sort keys %{main::f90included} ;
	print LATEX main::Build_Index_Chapter("source","index","Includes",$lang,@liste);
    }
}
#|#######################################################
sub Ouvre_SLatex {
    open(SLATEX,">$main::DIRE/Sindex.tex");
    $MonCode = $main::RepCodeSource ;
    $MonCode =~ s/_/\\_/g ;
print SLATEX <<'INFORMATION';
\documentclass[a4paper,10pt,twoside]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
%%\usepackage{french}
\textheight 23.0cm
\textwidth 16.0cm
\topmargin -0.55cm
\headsep 0.7cm
\marginparwidth 0.cm
\marginparsep 0.cm
\oddsidemargin 0.4cm
\evensidemargin -0.925cm 
\pagestyle{fancy}
\addtolength{\headwidth}{0cm}
\lfoot{\today}
INFORMATION
print SLATEX "\\rfoot{$main::USER}\n" ;
print SLATEX "\\lhead{Pr\\'esentation du code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print SLATEX "\\author{$main::USER}\n" ;
print SLATEX "\\title{Pr\\'sentation du code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\maketitle
%%\setcounter{page}{2}
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (SLATEX) ;
}

#|#######################################################
sub Ouvre_LLatex {
    open(LLATEX,">$main::DIRE/Lindex.tex");
    $MonCode = $main::RepCodeSource ;
    $MonCode =~ s/_/\\_/g ;
print LLATEX <<'INFORMATION';
\documentclass[a4paper,12pt]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
\lfoot{\today}
INFORMATION
print LLATEX "\\rfoot{$main::USER}\n" ;
print LLATEX "\\lhead{Pr\\'esentation du code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print LLATEX "\\author{$main::USER}\n" ;
print LLATEX "\\title{Pr\\'esentation du code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\maketitle
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (LLATEX) ;
} ;
#|#######################################################
sub OldGere_Latex {
    print LATEX "\\begin{itemize}\n" ;
    &Gere_Latex_Appelants ;
    &Gere_Latex_Appellees ;
    &Gere_Latex_Include ;
    print LATEX "\\end{itemize}\n" ;
} ;
#|#######################################################
sub Gere_Latex_Appelants {
    local($ligne)="";
    unless ($main::Appelants{$nom}) {
	$ligne .= "\\item {\\bf $Nom} n'est appel\\'e par personne.\n";
    }
    if ($main::Appelants{$nom}) {
	@liste_appels_complet = sort keys %{$main::Appelants{$nom}} ;
	unless (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} n'est appel\\'e par personne.\n";
	}
	if (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} est appel\\'e par:\n";
	    $ligne .= "\\begin{itemize}\n" ;
	    foreach $Routine (@liste_appels_complet) {
		$fichier=$main::File_Of_Rout{$Routine} ;
		$RoutEncour = main::GetAlias($Routine);
		$ROutine = $Routine ;
		$ROutine =~ s/_/\\_/g ;
		$ligne .= "\\item $ROutine [r\\'ef \\ref{$RoutEncour}, p. \\pageref{$RoutEncour}] ligne(s)";
		$numloc=1 ;
		foreach $num (sort main::numerique split(/ /, ${$main::Appelants{$nom}}{$Routine})) {
		    if ($numloc) {
			$numloc=0 ;
		    } else {
			$ligne .= ", ";
		    }
		    $ligne .= " ($num)";
		}
	        $ligne .= ".\n";
	    }
	    $ligne .= "\\end{itemize}\n";
	}
    }
    print LATEX "$ligne" ;
} ;

#|#######################################################
sub Gere_Latex_Appellees {
    local($nom)=@_;
    local($ligne)="";
    unless ($main::Appellees{$nom}) {
	$ligne .= "\\item {\\bf $Nom} n'appelle personne.\n";
    }
    if ($main::Appellees{$nom}) {
	@liste_appels_complet = sort keys %{$main::Appellees{$nom}} ;
	unless (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} n'appelle personne.\n";
	}
	if (@liste_appels_complet) {
	    $ligne .= "\\item {\\bf $Nom} appelle:\n";
	    $ligne .= "\\begin{itemize}\n" ;
	    $fichier=$main::File_Of_Rout{$nom} ;
	    foreach $Called_local (@liste_appels_complet) {
		$Reference = "";
		$Called_Minus = main::GetAlias($Called_local);
		if ($main::File_Of_Rout{$Called_local}) {
		    $Reference = $Called_local ;
		} elsif ($main::R_Declar{$Called_Minus}) {
		    $Reference = $main::R_Declar{$Called_Minus} ;
		}
		$CAlled_local = $Called_local ;
		$CAlled_local =~ s/_/\\_/g ;
		$Called_Minus = main::GetAlias($CAlled_local);
		$ligne .= "\\item ";
		if ($Reference) {
		    $ligne .= "$CAlled_local [r\\'ef \\ref{$Called_Minus}, p. \\pageref{$Called_Minus}] ligne(s)";
		} else {
		    $ligne .= "{\\it $CAlled_local} ligne(s)";
		}
		$numloc=1 ;
		foreach $num (sort main::numerique split(/ /, ${$main::Appellees{$nom}}{$Called_local})) {
	            if ($numloc) {
			$numloc=0 ;
		    } else {
			$ligne .= ", ";
		    }
		    $ligne .= " ($num)";
		}
	        $ligne .= ".\n";
           }
    }
	   $ligne .= "\\end{itemize}\n";
    }
print LATEX "$ligne" ;
} 

#|#######################################################
sub Gere_Latex_Include {
    local($Routine,$latexRoutine,$file)=@_;
    local($ligne)="";
    if ($main::fonctions_includes{$Routine}) {
	@liste_appels_complet = sort split(/ /, $main::fonctions_includes{$Routine});
	$ligne .= "\\item {\\bf $latexRoutine} utilise:\n";
	if (@liste_appels_complet) {
	    $ligne .= "\\begin{itemize}\n" ;
	    while (@liste_appels_complet) {
	        @liste_appels=split(/:/, shift @liste_appels_complet);
		shift @liste_appels;
		$fichier=shift @liste_appels;
		$num=shift @liste_appels;
		local($latexFichier) = main::LaTeXProtect($fichier);
		$ligne .= "\\item ";
		$ligne .= "$latexFichier";
		$ligne .= " ($num)\n";
		$niveau = 0 ;
		$Fichier0 = $fichier ;
		if ($main::fonctions_includes{$fichier}) {
		    if ( $niveau == 0 ){
			$ligne .= " qui utilise:\n";
		    } elsif ( $niveau == 2 ){
			$ligne .= ";\n $Fichier0 utilise aussi:\n";
		    } else {
			$ligne .= " qui utilise:\n";
		    }
		    $niveau = 1 ;
		    @liste_appels_completR = sort split(/ /, $main::fonctions_includes{$fichier});
		    while (@liste_appels_completR) {
		        @liste_appelsR=split(/:/, shift @liste_appels_completR);
		        shift @liste_appelsR ;
		        $fichier=shift @liste_appelsR ;
		        $num=shift @liste_appelsR ;
			local($latexFichier) = main::LaTeXProtect($fichier);
		        $ligne .= "$latexFichier";
		        $ligne .= " ($num)\n";
		        if ($main::fonctions_includes{$fichier}) {
		            $niveau = 2 ;
			    $ligne .= " qui utilise (rcursivit de niveau $niveau, maximum autoris):\n";
		            @liste_appels_completRR = sort split(/ /, $main::fonctions_includes{$fichier});
		            while (@liste_appels_completRR) {
		                @liste_appelsRR=split(/:/, shift @liste_appels_completRR);
		                shift @liste_appelsRR ;
		                $fichier=shift @liste_appelsRR ;
		                $num=shift @liste_appelsRR ;
				local($latexFichier) = main::LaTeXProtect($fichier);
		                $ligne .= "$latexFichier";
		                $ligne .= " ($num)\n";
		                if ($main::fonctions_includes{$fichier}) {
				    $ligne .= " qui utilise encore d'autres fichiers...\n";
		                }
		            }
		        }
		    }
		}
	    }
	    $ligne .= "\\end{itemize}\n" ;
	}
    }
    if ($main::fonctions_includes{$file}) {
	@liste_appels_complet = sort split(/ /, $file);
	$ligne .= "\\item {\\bf $latexRoutine} utilise en global:\n";
	if (@liste_appels_complet) {
	    $ligne .= "\\begin{itemize}\n" ;
	    while (@liste_appels_complet) {
	        @liste_appels=split(/:/, shift @liste_appels_complet);
		shift @liste_appels;
		$fichier=shift @liste_appels;
		$num=shift @liste_appels;
		local($latexFichier) = main::LaTeXProtect($fichier);
		$ligne .= "\\item ";
		$ligne .= "$latexFichier";
		$ligne .= " ($num)\n";
		$niveau = 0 ;
	    }
	    $ligne .= "\\end{itemize}\n" ;
	}
    }
    return ($ligne) ;
}

1;


